<?php
/**
 * @package Admin
 * @todo    Services page for WHMpress admin panel
 */

if ( ! defined( 'WHMP_VERSION' ) ) {
	wp_die("Direct acces not allowed by WHMPress", "Forbidden");
}

global $wpdb; ?>
<div class="wrap">
    <div class="whmp-main-title"><span class="whmp-title">WHMpress</span> <?php _e("Services", "whmpress") ?></div>
    
    <?php if (!WHMPress::WHMpress_synced()): ?>
    
    <div class="error">
        <p>
        <b>WHMPress <?php _e("Error", "whmpress") ?></b>
        <?php _e("WHMCS is not Synced", "whmpress") ?> <a href="admin.php?page=whmp-sync"><?php _e("Please Sync WHMCS", "whmpress") ?></a>.
        </p>
    </div>
    
    <?php else: ?>
    
    <div class="updated">
        <p>
        <?php _e("This page has all services list", "whmpress") ?>
        </p>
    </div>
    
    <?php
    $Q = "SELECT DISTINCT `type` FROM `".whmp_get_products_table_name()."` WHERE `type`<>''";
    $tabs = whmp_get_service_types();
    ?>
    
    <style>
    .mytr, .mytr th, .mytr th:hover {
        background-color: #666666 !important;
        color:#FFFFFF !important;
    }
    </style>
    
    <ul class='tabs'>
        <?php $k=1;
        foreach($tabs as $key=>$tab): ?>
        <li><a href='#tab<?php echo $k ?>'><?php echo $tab ?></a></li>
        <?php $k++; endforeach; ?>
        <li><a href="#domains"><?php _e("Domains", "whmpress") ?></a></li>
        <li><a href="#currencies"><?php _e("Currencies", "whmpress") ?></a></li>
    </ul>
    
    <?php $k=1;
    foreach($tabs as $key=>$tab) { ?>
    <div id='tab<?php echo $k ?>'>
        <table class="fancy" style="width:100%">
            <thead>
                <tr class="mytr">
                    <th style="width:25px"><?php _e("ID", "whmpress") ?></th>
                    <th style="width:30%"><?php _e("Name", "whmpress") ?></th>
                    <th><?php _e("Description", "whmpress") ?></th>
                </tr>
            </thead>
            <tbody>
                <?php
                $groups = $wpdb->get_results("SELECT `id`,`name`,`hidden` FROM `".whmp_get_product_group_table_name()."` ORDER BY `order`",ARRAY_A);
                foreach($groups as $group) {
                    $rows = $wpdb->get_results("SELECT `id`, `name`,`description`,`hidden` FROM `".whmp_get_products_table_name()."` WHERE `gid`='{$group["id"]}' AND `type`='{$key}' ORDER BY `name`");
                    if (is_array($rows) && sizeof($rows)>0) {
                        $hidden = $group["hidden"]=="on"?" (<i>Hidden</i>)":"";
                        echo "<tr><th colspan='3' style='text-align:center'>Group: ".$group["name"]." ({$group["id"]}) $hidden</th></tr>";
                        foreach($rows as $row): ?>
                        <tr>
                            <td><?php echo $row->id; ?></td>
                            <td><?php echo $row->name; if ($row->hidden=="on") echo " (<i>Hidden<i>)" ?></td>
                            <td><?php echo $row->description ?></td>
                        </tr>
                        <?php endforeach;
                    }
                } ?>
            </tbody>
        </table>
    </div>
    <?php $k++; } ?>
    
    <div id="domains">
        <?php $Q = "SELECT `id`,`extension` FROM `".whmp_get_domain_pricing_table_name()."` ORDER BY `order`";
        $rows = $wpdb->get_results($Q,ARRAY_A); ?>
        <div>You are selling <?php echo count($rows) ?> domain(s)</div>
        <table class="fancy" style="width:100%">
            <thead>
                <tr>
                    <th><?php _e("ID", "whmpress") ?></th>
                    <th><?php _e("Domain", "whmpress") ?></th>
                </tr>
            </thead>
            <tbody>
            <?php foreach($rows as $row): ?>
            <tr>
                <td><?php echo $row["id"] ?></td>
                <td><?php echo $row["extension"] ?></td>
            </tr>
            <?php endforeach; ?>
            </tbody>
        </table>
    </div>
    
    <div id="currencies">
        <?php $Q = "SELECT * FROM `".whmp_get_currencies_table_name()."`";
        $rows = $wpdb->get_results($Q,ARRAY_A); ?>
        <table class="fancy" style="width:100%">
            <thead>
                <tr>
                    <th><?php _e("ID", "whmpress") ?></th>
                    <th><?php _e("Code", "whmpress") ?></th>
                    <th><?php _e("Prefix", "whmpress") ?></th>
                    <th><?php _e("Suffix", "whmpress") ?></th>
                </tr>
            </thead>
            <tbody>
            <?php foreach($rows as $row): ?>
            <tr <?php if ($row["default"]=="1") echo "style='font-weight:bold'" ?>>
                <td><?php echo $row["id"] ?><?php if ($row["default"]=="1") echo " <sup>[default]</sup>" ?></td>
                <td><?php echo $row["code"] ?></td>
                <td><?php echo $row["prefix"] ?></td>
                <td><?php echo ($row["suffix"]); ?></td>
            </tr>
            <?php endforeach; ?>
            </tbody>
        </table>
    </div>
    <?php endif; ?>
</div>



<script type="text/javascript">
jQuery(document).ready(function () {
    jQuery('ul.tabs').each(function(){
    // For each set of tabs, we want to keep track of
    // which tab is active and it's associated content
    var $active, $content, $links = jQuery(this).find('a');

    // If the location.hash matches one of the links, use that as the active tab.
    // If no match is found, use the first link as the initial active tab.
    $active = jQuery($links.filter('[href="'+location.hash+'"]')[0] || $links[0]);
    $active.addClass('active');

    $content = jQuery($active[0].hash);

    // Hide the remaining content
    $links.not($active).each(function () {
        jQuery(this.hash).hide();
    });

    // Bind the click event handler
    jQuery(this).on('click', 'a', function(e){
      // Make the old tab inactive.
      $active.removeClass('active');
      $content.hide();

      // Update the variables with the new link and content
      $active = jQuery(this);
      $content = jQuery(this.hash);

      // Make the tab active.
      $active.addClass('active');
      $content.show();

      // Prevent the anchor's default click action
      e.preventDefault();
    });
  });
});
</script>